"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @private
 */
function flatten(object, separator = '.') {
    const isValidObject = (value) => {
        if (!value) {
            return false;
        }
        const isArray = Array.isArray(value);
        const isBuffer = Buffer.isBuffer(value);
        const isΟbject = Object.prototype.toString.call(value) === '[object Object]';
        const hasKeys = !!Object.keys(value).length;
        return !isArray && !isBuffer && isΟbject && hasKeys;
    };
    const walker = (child, path = []) => {
        return Object.assign({}, ...Object.keys(child).map((key) => isValidObject(child[key])
            ? walker(child[key], path.concat([key]))
            : { [path.concat([key]).join(separator)]: child[key] }));
    };
    return { ...walker(object) };
}
exports.flatten = flatten;
/**
 * @private
 */
function mergeRoles(dst, ...srcs) {
    for (const src of srcs) {
        for (const [key, val] of Object.entries(src)) {
            if (typeof val === 'object') {
                dst[key] = { ...dst[key], ...val };
            }
            else {
                dst[key] = val;
            }
        }
    }
    return dst;
}
exports.mergeRoles = mergeRoles;
//# sourceMappingURL=utils.js.map